#ifndef _INLINE_SOCKET_H
#define _INLINE_SOCKET_H

#include <sys/cdefs.h>
#include <inline/stubs.h>
/* for struct in ;-( */
#include <netinet/in.h>

__BEGIN_DECLS

#ifndef BASE_EXT_DECL
#define BASE_EXT_DECL extern struct Library * SockBase;
#endif
#ifndef BASE_PAR_DECL
#define BASE_PAR_DECL
#define BASE_PAR_DECL0 void
#endif
#ifndef BASE_NAME
#define BASE_NAME SockBase
#endif

static __inline int
accept (BASE_PAR_DECL int s,struct sockaddr * name,int * lenp)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register struct sockaddr * a0 __asm("a0") = name;
  register int * a1 __asm("a1") = lenp;
  __asm __volatile ("jsr a6@(-0xba)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
bind (BASE_PAR_DECL int s,struct sockaddr * name,int namelen)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register struct sockaddr * a1 __asm("a1") = name;
  register int d1 __asm("d1") = namelen;
  __asm __volatile ("jsr a6@(-0xc0)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a1), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline void
cleanup_sockets (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x24)"
  : /* no output */
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
}
static __inline int
connect (BASE_PAR_DECL int s,struct sockaddr * name,int namelen)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register struct sockaddr * a1 __asm("a1") = name;
  register int d1 __asm("d1") = namelen;
  __asm __volatile ("jsr a6@(-0xc6)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a1), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline void
endhostent (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x7e)"
  : /* no output */
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
}
static __inline void
endnetent (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x120)"
  : /* no output */
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
}
static __inline void
endprotoent (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x13e)"
  : /* no output */
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
}
static __inline void
endpwent (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x18c)"
  : /* no output */
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
}
static __inline void
endservent (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x15c)"
  : /* no output */
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
}
static __inline short
get_tz (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register short  _res	__asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x5a)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
getdomainname (BASE_PAR_DECL char * name,int namelen)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register char * a1 __asm("a1") = name;
  register int d1 __asm("d1") = namelen;
  __asm __volatile ("jsr a6@(-0x60)"
  : "=r" (_res)
  : "r" (a6), "r" (a1), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline gid_t
getgid (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register gid_t  _res	__asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x48)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
getgroups (BASE_PAR_DECL int num,gid_t * gids)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = num;
  register gid_t * a0 __asm("a0") = gids;
  __asm __volatile ("jsr a6@(-0x4e)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct hostent *
gethostbyaddr (BASE_PAR_DECL char * addr,int len,int type)
{
  BASE_EXT_DECL
  register struct hostent * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register char * a0 __asm("a0") = addr;
  register int d0 __asm("d0") = len;
  register int d1 __asm("d1") = type;
  __asm __volatile ("jsr a6@(-0x90)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct hostent *
gethostbyname (BASE_PAR_DECL char * name)
{
  BASE_EXT_DECL
  register struct hostent * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register char * a0 __asm("a0") = name;
  __asm __volatile ("jsr a6@(-0x8a)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct hostent *
gethostent (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct hostent * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x84)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
gethostname (BASE_PAR_DECL char * name,int length)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register char * a0 __asm("a0") = name;
  register int d0 __asm("d0") = length;
  __asm __volatile ("jsr a6@(-0x72)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline char *
getlogin (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register char * _res	__asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x54)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct netent *
getnetbyaddr (BASE_PAR_DECL long net,int type)
{
  BASE_EXT_DECL
  register struct netent * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register long d0 __asm("d0") = net;
  register int d1 __asm("d1") = type;
  __asm __volatile ("jsr a6@(-0x12c)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct netent *
getnetbyname (BASE_PAR_DECL char * name)
{
  BASE_EXT_DECL
  register struct netent * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register char * a0 __asm("a0") = name;
  __asm __volatile ("jsr a6@(-0x132)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct netent *
getnetent (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct netent * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x126)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
getpeername (BASE_PAR_DECL int s,struct sockaddr * name,int * lenp)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register struct sockaddr * a0 __asm("a0") = name;
  register int * a1 __asm("a1") = lenp;
  __asm __volatile ("jsr a6@(-0x198)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct protoent *
getprotobyname (BASE_PAR_DECL char * name)
{
  BASE_EXT_DECL
  register struct protoent * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register char * a0 __asm("a0") = name;
  __asm __volatile ("jsr a6@(-0x14a)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct protoent *
getprotobynumber (BASE_PAR_DECL int proto)
{
  BASE_EXT_DECL
  register struct protoent * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = proto;
  __asm __volatile ("jsr a6@(-0x150)"
  : "=r" (_res)
  : "r" (a6), "r" (d0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct protoent *
getprotoent (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct protoent * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x144)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct passwd *
getpwent (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct passwd * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x180)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct passwd *
getpwnam (BASE_PAR_DECL char * name)
{
  BASE_EXT_DECL
  register struct passwd * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register char * a0 __asm("a0") = name;
  __asm __volatile ("jsr a6@(-0x17a)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct passwd *
getpwuid (BASE_PAR_DECL uid_t uid)
{
  BASE_EXT_DECL
  register struct passwd * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register uid_t d1 __asm("d1") = uid;
  __asm __volatile ("jsr a6@(-0x174)"
  : "=r" (_res)
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct servent *
getservbyname (BASE_PAR_DECL char * name,char * proto)
{
  BASE_EXT_DECL
  register struct servent * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register char * a0 __asm("a0") = name;
  register char * a1 __asm("a1") = proto;
  __asm __volatile ("jsr a6@(-0x168)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct servent *
getservbyport (BASE_PAR_DECL u_short port,char * proto)
{
  BASE_EXT_DECL
  register struct servent * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register u_short d0 __asm("d0") = port;
  register char * a0 __asm("a0") = proto;
  __asm __volatile ("jsr a6@(-0x16e)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct servent *
getservent (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct servent * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x162)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
getsockname (BASE_PAR_DECL int s,struct sockaddr * name,int * lenp)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register struct sockaddr * a0 __asm("a0") = name;
  register int * a1 __asm("a1") = lenp;
  __asm __volatile ("jsr a6@(-0x19e)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
getsockopt (BASE_PAR_DECL int s,int level,int optname,char * optval,int * optlenp)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register int d1 __asm("d1") = level;
  register int d2 __asm("d2") = optname;
  register char * a0 __asm("a0") = optval;
  register int * a1 __asm("a1") = optlenp;
  __asm __volatile ("jsr a6@(-0x114)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (d1), "r" (d2), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1","d2", "memory");
  return _res;
}
static __inline uid_t
getuid (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register uid_t  _res	__asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x42)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline mode_t
getumask (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register mode_t  _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x66)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline u_long
inet_addr (BASE_PAR_DECL char * cp)
{
  BASE_EXT_DECL
  register u_long  _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register char * a1 __asm("a1") = cp;
  __asm __volatile ("jsr a6@(-0x96)"
  : "=r" (_res)
  : "r" (a6), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
inet_lnaof (BASE_PAR_DECL struct in_addr in)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct in_addr d1 __asm("d1") = in;
  __asm __volatile ("jsr a6@(-0xa2)"
  : "=r" (_res)
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline struct in_addr
inet_makeaddr (BASE_PAR_DECL int net,int lna)
{
  BASE_EXT_DECL
  register struct in_addr  _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = net;
  register int d1 __asm("d1") = lna;
  __asm __volatile ("jsr a6@(-0x9c)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
inet_netof (BASE_PAR_DECL struct in_addr in)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct in_addr d1 __asm("d1") = in;
  __asm __volatile ("jsr a6@(-0xa8)"
  : "=r" (_res)
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
inet_network (BASE_PAR_DECL char * str)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register char * a1 __asm("a1") = str;
  __asm __volatile ("jsr a6@(-0xae)"
  : "=r" (_res)
  : "r" (a6), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline char *
inet_ntoa (BASE_PAR_DECL struct in_addr in)
{
  BASE_EXT_DECL
  register char * _res	__asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct in_addr d1 __asm("d1") = in;
  __asm __volatile ("jsr a6@(-0xb4)"
  : "=r" (_res)
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
listen (BASE_PAR_DECL int s,int backlog)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register int d1 __asm("d1") = backlog;
  __asm __volatile ("jsr a6@(-0xd2)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
rcmd (BASE_PAR_DECL char **ahost,u_short inport,char * luser,char * ruser,char * cmd,int * fd2p)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register char **d0 __asm("d0") = ahost;
  register u_short d1 __asm("d1") = inport;
  register char * a0 __asm("a0") = luser;
  register char * a1 __asm("a1") = ruser;
  register char * a2 __asm("a2") = cmd;
  register int * d2 __asm("d2") = fd2p;
  __asm __volatile ("jsr a6@(-0x192)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (d1), "r" (a0), "r" (a1), "r" (a2), "r" (d2)
  : "a0","a1","a2","d0","d1","d2", "memory");
  return _res;
}
static __inline int
reconfig (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x1aa)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
recv (BASE_PAR_DECL int s,char * buf,int len,int flags)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register char * a0 __asm("a0") = buf;
  register int d1 __asm("d1") = len;
  register int d2 __asm("d2") = flags;
  __asm __volatile ("jsr a6@(-0xd8)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (d1), "r" (d2)
  : "a0","a1","d0","d1","d2", "memory");
  return _res;
}
static __inline int
recvfrom (BASE_PAR_DECL int s,char * buf,int len,int flags,struct sockaddr * from,int * fromlen)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register char * a0 __asm("a0") = buf;
  register int d1 __asm("d1") = len;
  register int d2 __asm("d2") = flags;
  register struct sockaddr * a1 __asm("a1") = from;
  register int * a2 __asm("a2") = fromlen;
  __asm __volatile ("jsr a6@(-0xde)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (d1), "r" (d2), "r" (a1), "r" (a2)
  : "a0","a1","a2","d0","d1","d2", "memory");
  return _res;
}
static __inline int
recvmsg (BASE_PAR_DECL int s,struct msghdr * msg,int flags)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register struct msghdr *a0 __asm("a0") = msg;
  register int d1 __asm("d1") = flags;
  __asm __volatile ("jsr a6@(-0xe4)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
s_close (BASE_PAR_DECL	int socket)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register  int d0 __asm("d0") = socket;
  __asm __volatile ("jsr a6@(-0x30)"
  : "=r" (_res)
  : "r" (a6), "r" (d0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline void
s_dev_list (BASE_PAR_DECL u_long res,int size)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register u_long d0 __asm("d0") = res;
  register int d1 __asm("d1") = size;
  __asm __volatile ("jsr a6@(-0x1bc)"
  : /* no output */
  : "r" (a6), "r" (d0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
}
static __inline BYTE
s_getsignal (BASE_PAR_DECL UWORD type)
{
  BASE_EXT_DECL
  register BYTE  _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register UWORD d1 __asm("d1") = type;
  __asm __volatile ("jsr a6@(-0x36)"
  : "=r" (_res)
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
s_inherit (BASE_PAR_DECL void * sp)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register void * d1 __asm("d1") = sp;
  __asm __volatile ("jsr a6@(-0x1b6)"
  : "=r" (_res)
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
s_ioctl (BASE_PAR_DECL int s,int cmd,char * data)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register int d1 __asm("d1") = cmd;
  register char * a0 __asm("a0") = data;
  __asm __volatile ("jsr a6@(-0xcc)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (d1), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline void *
s_release (BASE_PAR_DECL int s)
{
  BASE_EXT_DECL
  register void * _res	__asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d1 __asm("d1") = s;
  __asm __volatile ("jsr a6@(-0x1b0)"
  : "=r" (_res)
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
s_syslog (BASE_PAR_DECL int pri,char * msg)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = pri;
  register char * a0 __asm("a0") = msg;
  __asm __volatile ("jsr a6@(-0x1a4)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
select (BASE_PAR_DECL int numfds,fd_set * rfds,fd_set * wfds,fd_set * efds,struct timeval * timeout)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = numfds;
  register fd_set * a0 __asm("a0") = rfds;
  register fd_set * a1 __asm("a1") = wfds;
  register fd_set * a2 __asm("a2") = efds;
  register struct timeval * d1 __asm("d1") = timeout;
  __asm __volatile ("jsr a6@(-0xea)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (a1), "r" (a2), "r" (d1)
  : "a0","a1","a2","d0","d1", "memory");
  return _res;
}
static __inline int
selectwait (BASE_PAR_DECL int numfds,fd_set * rfds,fd_set * wfds,fd_set * efds,struct timeval * timeout,long * umask)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = numfds;
  register fd_set * a0 __asm("a0") = rfds;
  register fd_set * a1 __asm("a1") = wfds;
  register fd_set * a2 __asm("a2") = efds;
  register struct timeval * d1 __asm("d1") = timeout;
  register long * d2 __asm("d2") = umask;
  __asm __volatile ("jsr a6@(-0xf0)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (a1), "r" (a2), "r" (d1), "r" (d2)
  : "a0","a1","a2","d0","d1","d2", "memory");
  return _res;
}
static __inline int
send (BASE_PAR_DECL int s,char * buf,int len,int flags)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register char * a0 __asm("a0") = buf;
  register int d1 __asm("d1") = len;
  register int a1 __asm("a1") = flags;
  __asm __volatile ("jsr a6@(-0xf6)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (d1), "r" (a1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
sendmsg (BASE_PAR_DECL int s,struct msghdr * msg,int flags)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register struct msghdr *a0 __asm("a0") = msg;
  register int d1 __asm("d1") = flags;
  __asm __volatile ("jsr a6@(-0x102)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
sendto (BASE_PAR_DECL int s,char * buf,int len,int flags,struct sockaddr * to,int to_len)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register char * a0 __asm("a0") = buf;
  register int d1 __asm("d1") = len;
  register int d2 __asm("d2") = flags;
  register struct sockaddr * a1 __asm("a1") = to;
  register int d3 __asm("d3") = to_len;
  __asm __volatile ("jsr a6@(-0xfc)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (a0), "r" (d1), "r" (d2), "r" (a1), "r" (d3)
  : "a0","a1","d0","d1","d2","d3", "memory");
  return _res;
}
static __inline void
sethostent (BASE_PAR_DECL int flag)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d1 __asm("d1") = flag;
  __asm __volatile ("jsr a6@(-0x78)"
  : /* no output */
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
}
static __inline void
setnetent (BASE_PAR_DECL int flag)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d1 __asm("d1") = flag;
  __asm __volatile ("jsr a6@(-0x11a)"
  : /* no output */
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
}
static __inline void
setprotoent (BASE_PAR_DECL int flag)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d1 __asm("d1") = flag;
  __asm __volatile ("jsr a6@(-0x138)"
  : /* no output */
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
}
static __inline void
setpwent (BASE_PAR_DECL int flag)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d1 __asm("d1") = flag;
  __asm __volatile ("jsr a6@(-0x186)"
  : /* no output */
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
}
static __inline void
setservent (BASE_PAR_DECL int flag)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d1 __asm("d1") = flag;
  __asm __volatile ("jsr a6@(-0x156)"
  : /* no output */
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
}
static __inline int
setsockopt (BASE_PAR_DECL int s,int level,int optname,char * optval,int optlen)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register int d1 __asm("d1") = level;
  register int d2 __asm("d2") = optname;
  register char * a0 __asm("a0") = optval;
  register int d3 __asm("d3") = optlen;
  __asm __volatile ("jsr a6@(-0x10e)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (d1), "r" (d2), "r" (a0), "r" (d3)
  : "a0","a1","d0","d1","d2","d3", "memory");
  return _res;
}
static __inline ULONG
setup_sockets (BASE_PAR_DECL UWORD max_socks,int * errno_ptr)
{
  BASE_EXT_DECL
  register ULONG  _res	__asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register UWORD d1 __asm("d1") = max_socks;
  register int * a0 __asm("a0") = errno_ptr;
  __asm __volatile ("jsr a6@(-0x1e)"
  : "=r" (_res)
  : "r" (a6), "r" (d1), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
shutdown (BASE_PAR_DECL int s,int how)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = s;
  register int d1 __asm("d1") = how;
  __asm __volatile ("jsr a6@(-0x108)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline int
socket (BASE_PAR_DECL int family,int type,int protocol)
{
  BASE_EXT_DECL
  register int	_res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d0 __asm("d0") = family;
  register int d1 __asm("d1") = type;
  register int d2 __asm("d2") = protocol;
  __asm __volatile ("jsr a6@(-0x2a)"
  : "=r" (_res)
  : "r" (a6), "r" (d0), "r" (d1), "r" (d2)
  : "a0","a1","d0","d1","d2", "memory");
  return _res;
}
static __inline char *
strerror (BASE_PAR_DECL int num)
{
  BASE_EXT_DECL
  register char * _res	__asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register int d1 __asm("d1") = num;
  __asm __volatile ("jsr a6@(-0x3c)"
  : "=r" (_res)
  : "r" (a6), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
static __inline mode_t
umask (BASE_PAR_DECL mode_t cmask)
{
  BASE_EXT_DECL
  register mode_t  _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register mode_t d0 __asm("d0") = cmask;
  __asm __volatile ("jsr a6@(-0x6c)"
  : "=r" (_res)
  : "r" (a6), "r" (d0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
#undef BASE_EXT_DECL
#undef BASE_PAR_DECL
#undef BASE_PAR_DECL0
#undef BASE_NAME

__END_DECLS

#endif /* _INLINE_SOCKET_H */

